SoSceneManager Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoSceneManager Class Reference
Miscellaneous Classes

The SoSceneManager class provides the main interface between the scene graph and the GUI toolkit.The renderarea class from the GUI toolkit you are using uses this class as the interface against the scene graph. Event handling and providing "hooks" to do rendering are the main functions of the class. More...

`#include <Inventor/SoSceneManager.h>`

## Public Member Functions
| SoSceneManager (void)
virtual | ~SoSceneManager ()
virtual void | render (const SbBool clearwindow=TRUE, const SbBool clearzbuffer=TRUE)
virtual void | render (SoGLRenderAction *action, const SbBool initmatrices=TRUE, const SbBool clearwindow=TRUE, const SbBool clearzbuffer=TRUE)
void | setCamera (SoCamera *camera)
SoCamera * | getCamera (void) const
virtual SbBool | processEvent (const SoEvent *const event)
void | reinitialize (void)
void | scheduleRedraw (void)
virtual void | setSceneGraph (SoNode *const sceneroot)
virtual SoNode * | getSceneGraph (void) const
void | setWindowSize (const SbVec2s &newsize)
const SbVec2s & | getWindowSize (void) const
void | setSize (const SbVec2s &newsize)
const SbVec2s & | getSize (void) const
void | setOrigin (const SbVec2s &newOrigin)
const SbVec2s & | getOrigin (void) const
void | setViewportRegion (const SbViewportRegion &newRegion)
const SbViewportRegion & | getViewportRegion (void) const
void | setBackgroundColor (const SbColor &color)
const SbColor & | getBackgroundColor (void) const
void | setBackgroundIndex (const int index)
int | getBackgroundIndex (void) const
void | setRGBMode (const SbBool onOrOff)
SbBool | isRGBMode (void) const
virtual void | activate (void)
virtual void | deactivate (void)
void | setRenderCallback (SoSceneManagerRenderCB *f, void *const userData=NULL)
SbBool | isAutoRedraw (void) const
void | setRedrawPriority (const uint32_t priority)
uint32_t | getRedrawPriority (void) const
void | setAntialiasing (const SbBool smoothing, const int numPasses)
void | getAntialiasing (SbBool &smoothing, int &numPasses) const
void | setGLRenderAction (SoGLRenderAction *const action)
SoGLRenderAction * | getGLRenderAction (void) const
void | setAudioRenderAction (SoAudioRenderAction *const action)
SoAudioRenderAction * | getAudioRenderAction (void) const
void | setHandleEventAction (SoHandleEventAction *hea)
SoHandleEventAction * | getHandleEventAction (void) const

## Static Public Member Functions
static uint32_t | getDefaultRedrawPriority (void)
static void | enableRealTimeUpdate (const SbBool flag)
static SbBool | isRealTimeUpdateEnabled (void)

## Protected Member Functions
int | isActive (void) const
void | redraw (void)

## Detailed Description

The SoSceneManager class provides the main interface between the scene graph and the GUI toolkit.

The renderarea class from the GUI toolkit you are using uses this class as the interface against the scene graph. Event handling and providing "hooks" to do rendering are the main functions of the class.

A Coin library instance within an application will typically contain a single SoSceneManager object. The pointer for this object is stored in the GUI renderarea class.

## Constructor & Destructor Documentation

SoSceneManager::SoSceneManager | ( | void |  | ) |

Constructor. Sets up default SoGLRenderAction and SoHandleEventAction instances.

SoSceneManager::~SoSceneManager | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

void SoSceneManager::render | ( | const SbBool | clearwindow = `TRUE`,
|  | const SbBool | clearzbuffer = `TRUE`
| ) |  |
| virtual

Render the scene graph.

If clearwindow is `TRUE`, clear the rendering buffer before drawing. If clearzbuffer is `TRUE`, clear the depth buffer values before rendering. Both of these arguments should normally be `TRUE`, but they can be set to `FALSE` to optimize for special cases (e.g. when doing wireframe rendering one doesn't need a depth buffer).

void SoSceneManager::render | ( | SoGLRenderAction * | action,
|  | const SbBool | initmatrices = `TRUE`,
|  | const SbBool | clearwindow = `TRUE`,
|  | const SbBool | clearzbuffer = `TRUE`
| ) |  |
| virtual

Render method used for thread safe rendering.

Since only one thread can use an SoGLRenderAction, this method enables you to supply your own thread-specific SoGLRenderAction to be used for rendering the scene.

If initmatrices is `TRUE`, the OpenGL model and projection matrices will be initialized to identity matrices before applying the action.

If clearwindow is `TRUE`, clear the rendering buffer before drawing. If clearzbuffer is `TRUE`, clear the depth buffer values before rendering.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

void SoSceneManager::setCamera | ( | SoCamera * | camera | ) |

Sets the camera to be used.

SoCamera * SoSceneManager::getCamera | ( | void |  | ) | const

Returns the current camera.

SbBool SoSceneManager::processEvent | ( | const SoEvent *const | event | ) |
| virtual

Process the given event by applying an SoHandleEventAction on the scene graph.

void SoSceneManager::reinitialize | ( | void |  | ) |

Reinitialize after parameters affecting the OpenGL context has changed.

void SoSceneManager::scheduleRedraw | ( | void |  | ) |

Redraw at first opportunity as system becomes idle.

Multiple calls to this method before an actual redraw has taken place will only result in a single redraw of the scene.

void SoSceneManager::setSceneGraph | ( | SoNode *const | sceneroot | ) |
| virtual

Set the node which is top of the scene graph we're managing. The sceneroot node reference count will be increased by 1, and any previously set scene graph top node will have it's reference count decreased by 1.

See also
  getSceneGraph()

SoNode * SoSceneManager::getSceneGraph | ( | void |  | ) | const
| virtual

Returns pointer to root of scene graph.

void SoSceneManager::setWindowSize | ( | const SbVec2s & | newsize | ) |

Update window size of our SoGLRenderAction's viewport settings.

Note that this will only change the information about window dimensions, the actual viewport size and origin (ie the rectangle which redraws are confined to) will stay the same.

See also
  setViewportRegion()

const SbVec2s & SoSceneManager::getWindowSize | ( | void |  | ) | const

Returns the current render action window size.

See also
  setWindowSize()

void SoSceneManager::setSize | ( | const SbVec2s & | newsize | ) |

Set size of rendering area for the viewport within the current window.

const SbVec2s & SoSceneManager::getSize | ( | void |  | ) | const

Returns size of render area.

void SoSceneManager::setOrigin | ( | const SbVec2s & | newOrigin | ) |

Set only the origin of the viewport region within the rendering window.

See also
  setViewportRegion(), setWindowSize()

const SbVec2s & SoSceneManager::getOrigin | ( | void |  | ) | const

Returns origin of rendering area viewport.

See also
  setOrigin()

void SoSceneManager::setViewportRegion | ( | const SbViewportRegion & | newregion | ) |

Update our SoGLRenderAction's viewport settings.

This will change both the information about window dimensions and the actual viewport size and origin.

See also
  setWindowSize()

const SbViewportRegion & SoSceneManager::getViewportRegion | ( | void |  | ) | const

Returns current viewport region used by the renderaction and the event handling.

See also
  setViewportRegion()

void SoSceneManager::setBackgroundColor | ( | const SbColor & | color | ) |

Sets color of rendering canvas.

const SbColor & SoSceneManager::getBackgroundColor | ( | void |  | ) | const

Returns color used for clearing the rendering area before rendering the scene.

void SoSceneManager::setBackgroundIndex | ( | const int | index | ) |

Set index of background color in the color lookup table if rendering in colorindex mode.

Note: colorindex mode is not supported yet in Coin.

int SoSceneManager::getBackgroundIndex | ( | void |  | ) | const

Returns index of colormap for background filling.

See also
  setBackgroundIndex()

void SoSceneManager::setRGBMode | ( | const SbBool | yes | ) |

Turn RGB truecolor mode on or off. If you turn truecolor mode off, colorindex mode will be used instead.

SbBool SoSceneManager::isRGBMode | ( | void |  | ) | const

Returns the "truecolor or colorindex" mode flag.

void SoSceneManager::activate | ( | void |  | ) |
| virtual

Activate rendering and event handling. Default is `off`.

void SoSceneManager::deactivate | ( | void |  | ) |
| virtual

Deactive rendering and event handling.

void SoSceneManager::setRenderCallback | ( | SoSceneManagerRenderCB * | f,
|  | void *const | userdata = `NULL`
| ) |  |

Set the callback function f to invoke when rendering the scene. userdata will be passed as the first argument of the function.

SbBool SoSceneManager::isAutoRedraw | ( | void |  | ) | const

Returns `TRUE` if the SoSceneManager automatically redraws the scene upon detecting changes in the scene graph.

The automatic redraw is turned on and off by setting either a valid callback function with setRenderCallback(), or by passing `NULL`.

void SoSceneManager::setRedrawPriority | ( | const uint32_t | priority | ) |

Set up the redraw priority for the SoOneShotSensor used to trigger redraws. By setting this lower than for your own sensors, you can make sure some code is always run before redraw happens.

See also
  SoDelayQueueSensor

uint32_t SoSceneManager::getRedrawPriority | ( | void |  | ) | const

Returns value of priority on the redraw sensor.

void SoSceneManager::setAntialiasing | ( | const SbBool | smoothing,
|  | const int | numpasses
| ) |  |

Turn antialiased rendering on or off.

See documentation for SoGLRenderAction::setSmoothing() and SoGLRenderAction::setNumPasses().

void SoSceneManager::getAntialiasing | ( | SbBool & | smoothing,
|  | int & | numpasses
| ) |  | const

Returns rendering pass information.

See also
  setAntialiasing()

void SoSceneManager::setGLRenderAction | ( | SoGLRenderAction *const | action | ) |

Set the action to use for rendering. Overrides the default action made in the constructor.

SoGLRenderAction * SoSceneManager::getGLRenderAction | ( | void |  | ) | const

Returns pointer to render action.

void SoSceneManager::setAudioRenderAction | ( | SoAudioRenderAction *const | action | ) |

Set the action to use for rendering audio. Overrides the default action made in the constructor.

SoAudioRenderAction * SoSceneManager::getAudioRenderAction | ( | void |  | ) | const

Returns pointer to audio render action.

void SoSceneManager::setHandleEventAction | ( | SoHandleEventAction * | hea | ) |

Set the action to use for event handling. Overrides the default action made in the constructor.

SoHandleEventAction * SoSceneManager::getHandleEventAction | ( | void |  | ) | const

Returns pointer to event handler action.

uint32_t SoSceneManager::getDefaultRedrawPriority | ( | void |  | ) |
| static

Returns the default priority of the redraw sensor.

See also
  SoDelayQueueSensor, setRedrawPriority()

void SoSceneManager::enableRealTimeUpdate | ( | const SbBool | flag | ) |
| static

Set whether or not for SoSceneManager instances to "touch" the global `realTime` field after a redraw. If this is not done, redrawing when animating the scene will only happen as fast as the `realTime` interval goes (which defaults to 12 times a second).

See also
  SoDB::setRealTimeInterval()

SbBool SoSceneManager::isRealTimeUpdateEnabled | ( | void |  | ) |
| static

Returns whether or not we automatically notifies everything connected to the `realTime` field after a redraw.

int SoSceneManager::isActive | ( | void |  | ) | const
| protected

Returns the active flag.

void SoSceneManager::redraw | ( | void |  | ) |
| protected

Do an immediate redraw by calling the redraw callback function.

The documentation for this class was generated from the following files:

- SoSceneManager.h
- SoSceneManager.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.